// --------------------------------------------------------------------
// Projet POBOT Carte CNP.     		                             			---
// Dclaration Fonctions & Variables Timer. Version 1.0.           	---
//                                                                  ---
// Cr le 30 Janvier 2006 par Spinelli Gilles.                    	---
// --------------------------------------------------------------------

// -----------------------------------------
// ----- Global Constants Declaration. -----
// -----------------------------------------


// -----------------------------------------
// ----- Global Variables Declaration. -----
// -----------------------------------------

// -- iTimer_CptS est le timer utilis par la bibliothque Srie (evite appel S/P). --
// -- lClock_Second est la dure coule en seconde depuis l'appel  Clock_Init. 		--
// -- bTimer_FlagCpt passe  TRUE lorsque que le Timer (fct Timer)  fini.				  --
// -- bTimer_FlagS est le flag utilis par la bibliothque Srie (evite appel S/P). --
// -- bTimer_FlagS passe  TRUE lorsqu'une seconde est passe (Clock_Init). Ce flag --
// -- doit tre remis  FALSE par l'utilisateur s'il veut l'utiliser rgulirement. --

extern volatile unsigned int           	iTimer_CptS;
extern volatile unsigned long						lClock_Second;	

extern volatile struct structFlags     	sTimer_Flag;
#define bTimer_FlagCpt        sTimer_Flag.bit0
#define bTimer_FlagS          sTimer_Flag.bit1
#define bTimer_FlagClk				sTimer_Flag.bit2



// -----------------------------------------
// ----- Global Functions Declaration. -----
// -----------------------------------------

// -- Timer_Init initialise le Timer Millisecondes, bas sur Timer0 OverFLow. 		--
// -- Toutes les ms, un interruption est gnre et travaille avec les diffrents --
// -- compteurs et flags lancs par les fonctions suivantes.											--
// -- ATTENTION : les interruptions doivent tre 'enable' avant de lancer ce S/P. --

// -- TimerStandBy arrte le Timer Millisecondes. 																--

// -- Timer lance un Timer pour une dure de iTime millisecondes puis ressort.		--
// -- Temps demand est coul lorsque bTimer_FlagCpt = TRUE.											--

// -- Delay attend une dure de iTime millisecondes avant de rendre la main.			-- 

// -- Wait_MicroSecond attend une dure de iTime microsecondes avant de sortir.		-- 
// -- Wait_100MicroSecond attend "iTime x 0.1" millisecondes avant de sortir.			-- 
// -- ATTENTION : ces deux derniers S/P n'ont pas t calibr pour le quartz 16MHz--

// -- Clock_Init.	Lance une horloge Temps Rel en seconde, donn par lClock_Second-- 
// -- Toutes les secondes, bTimer_FlagClk passe  TRUE. Il peut tre reinitialis -- 
// -- par l'utilisateur qui veut savoir quand changent les secondes.							--

// -- Clock_Conversion : convertit "l'heure" au format ASCII "HH:MM:SS" et le 		--
// -- stocke dans szBuffer.																												-- 

void          Timer_Init(void);
void          Timer_StandBy(void);

void          Timer(unsigned int iTime);
void          Delay(unsigned int iTime);

void          Wait_MicroSecond(unsigned int iTime);
void          Wait_100MicroSecond(unsigned int iTime);

void					Clock_Init(void);
void					Clock_Conversion(unsigned char * szBuffer);


// -- Timer_Color : Spcifique POBOT. 																						--
// -- Lance sur le port PD7 l'alternance Bleu/Rouge pour la led clairante.				--
// -- Echantillonne toutes les mS les donnes Capteur et en dduit si il y a 			--
// -- rflexion ou pas. Exploite les variables gnrales suivantes :							-- 
// -- bColor_BlueOn : indique si couleur en cours est bleu(TRUE) ou rouge(FALSE).	-- 
// -- bColor_Change : indique si au moins une couleur a chang.										--
// -- cColor_G, cColor_R : indique la couleur sur le capteur Gauche ou Droit.			-- 
// -- Ces deux valeurs valent 0x00 pour RIEN, 0x01 pour Rouge et 0x02 pour Bleu. 	--

void 					Timer_Color(void);

